VERSION 5.00
Begin VB.Form NntpForm 
   Caption         =   "NNTP Client"
   ClientHeight    =   7035
   ClientLeft      =   900
   ClientTop       =   945
   ClientWidth     =   7560
   LinkTopic       =   "Form1"
   ScaleHeight     =   7035
   ScaleWidth      =   7560
   Begin VB.CommandButton C_Connect 
      Caption         =   "Connect"
      Height          =   285
      Left            =   6120
      TabIndex        =   11
      Top             =   120
      Width           =   1335
   End
   Begin VB.CheckBox CheckHeader 
      Caption         =   "inkl. Header"
      Height          =   195
      Left            =   1320
      TabIndex        =   10
      Top             =   3015
      Visible         =   0   'False
      Width           =   4095
   End
   Begin VB.CommandButton C_GetSubjects 
      Caption         =   "Get Subjects"
      Enabled         =   0   'False
      Height          =   285
      Left            =   2880
      TabIndex        =   5
      Top             =   840
      Width           =   1575
   End
   Begin VB.CommandButton C_Show 
      Caption         =   "Show"
      Enabled         =   0   'False
      Height          =   255
      Left            =   120
      TabIndex        =   8
      Top             =   3000
      Visible         =   0   'False
      Width           =   1095
   End
   Begin VB.ListBox L_Mails 
      Height          =   1425
      Left            =   120
      TabIndex        =   7
      Top             =   1560
      Width           =   7335
   End
   Begin VB.TextBox T_Group 
      Height          =   285
      IMEMode         =   3  'DISABLE
      Left            =   1080
      TabIndex        =   3
      Top             =   480
      Width           =   4935
   End
   Begin VB.TextBox T_Mail 
      Height          =   3615
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Beides
      TabIndex        =   9
      Top             =   3360
      Width           =   7335
   End
   Begin VB.CommandButton C_GetAllGroups 
      Caption         =   "Get All Groups"
      Enabled         =   0   'False
      Height          =   285
      Left            =   1080
      TabIndex        =   4
      Top             =   840
      Width           =   1575
   End
   Begin VB.TextBox T_Server 
      Height          =   285
      Left            =   1080
      TabIndex        =   1
      Top             =   120
      Width           =   4935
   End
   Begin VB.Label L_Liste 
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   1320
      Width           =   7335
   End
   Begin VB.Label Label3 
      Caption         =   "Gruppe:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   525
      Width           =   1095
   End
   Begin VB.Label Label1 
      Caption         =   "Nntp-Server:"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   165
      Width           =   1095
   End
End
Attribute VB_Name = "NntpForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private WithEvents nntp As NntpClient
Attribute nntp.VB_VarHelpID = -1
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long

Private Sub C_Connect_Click()

Screen.MousePointer = 11
If C_Connect.Caption = "Connect" Then
   L_Mails.Clear
   T_Mail.Text = ""
   nntp.Server = T_Server.Text
   If nntp.Connect() Then
      C_Connect.Caption = "Disconnect"
      T_Server.Enabled = False
      C_GetAllGroups.Enabled = True
      C_GetSubjects.Enabled = True
   Else
      L_Mails.AddItem "--- " + nntp.LastError + " ---"
   End If
Else
   nntp.Disconnect
   C_Connect.Caption = "Connect"
   T_Server.Enabled = True
   C_GetAllGroups.Enabled = False
   C_GetSubjects.Enabled = False
End If
Screen.MousePointer = 0

End Sub

Private Sub C_GetAllGroups_Click()

Screen.MousePointer = 11
L_Liste = "Gruppen:"
C_Show.Visible = False
CheckHeader.Visible = False
L_Mails.Clear

If Not nntp.GetAllGroups() Then
   L_Mails.AddItem "--- " + nntp.LastError + " ---"
End If

Screen.MousePointer = 0

End Sub

Private Sub C_GetSubjects_Click()

Screen.MousePointer = 11
L_Liste = "Artikel:"
C_Show.Visible = True
CheckHeader.Visible = True
L_Mails.Clear

If Not nntp.GetMessages%(T_Group.Text) Then
   L_Mails.AddItem "--- " + nntp.LastError + " ---"
End If

Screen.MousePointer = 0

End Sub

Private Sub C_Show_Click()

If L_Mails.ListIndex < 0 Then Exit Sub
id& = L_Mails.ItemData(L_Mails.ListIndex)

Screen.MousePointer = 11
If CheckHeader.Value Then
   T_Mail.Text = nntp.GetMessage(id&)
Else
   T_Mail.Text = nntp.GetMessageBody(id&)
End If
Screen.MousePointer = 0

End Sub

Private Sub Form_Load()

Set nntp = New NntpClient
T_Server.Text = ini$("Server")
T_Group.Text = ini$("Group")

End Sub

Private Sub Form_Resize()

If Me.WindowState = 1 Then Exit Sub
If Me.ScaleWidth - C_Connect.Width - 120 > T_Server.Left + 240 Then C_Connect.Left = Me.ScaleWidth - C_Connect.Width - 120
If C_Connect.Left - T_Server.Left > 120 Then T_Server.Width = C_Connect.Left - T_Server.Left - 120
T_Group.Width = T_Server.Width
If Me.ScaleWidth > 240 Then L_Mails.Width = Me.ScaleWidth - 240
If Me.ScaleWidth > 240 Then T_Mail.Width = Me.ScaleWidth - 240
If Me.ScaleHeight - T_Mail.Top > 120 Then T_Mail.Height = Me.ScaleHeight - T_Mail.Top - 120

End Sub

Private Sub Form_Unload(Cancel As Integer)

Set nntp = Nothing

End Sub

Private Sub L_Mails_Click()

If C_Connect.Caption = "Disconnect" Then
   C_Show.Enabled = True
End If

End Sub

Private Sub L_Mails_DblClick()

If C_Show.Visible Then
   If C_Show.Enabled Then C_Show_Click
Else
   a$ = L_Mails.Text
   If InStr(a$, " ") Then a$ = Left$(a$, InStr(a$, " ") - 1)
   T_Group.Text = a$
End If

End Sub

Function ini$(key$)

Dim a As String * 255
l& = GetPrivateProfileString("Nntp", key$, "", a$, 255, App.Path + "\config.ini")
ini$ = Left$(a$, l&)

End Function

Private Sub nntp_ListArticles(id As Long)

L_Mails.AddItem nntp.GetMessageSubject(id)
L_Mails.ItemData(L_Mails.NewIndex) = id
L_Mails.Refresh

End Sub

Private Sub nntp_ListGroups(group As String)

L_Mails.AddItem group
If (L_Mails.ListCount Mod 100) = 0 Then L_Mails.TopIndex = L_Mails.ListCount - 1: L_Mails.Refresh

End Sub
